﻿WG_Settings = {}

local frame=CreateFrame('MessageFrame', 'WG_SCTFRAME', UIParent)
frame:SetWidth(UIParent:GetWidth())
frame:SetWidth(600)
frame:SetHeight(60)
frame:SetFrameStrata('HIGH')
frame:SetTimeVisible(8)
frame:SetFadeDuration(0.4)
frame:SetPoint('CENTER', 0, 180)
frame:SetFontObject(GameFontNormalLarge)
frame:Show();

function WG_OnLoad()
	this:RegisterEvent("PLAYER_LOGIN");
	this:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE");
	this:RegisterEvent("UNIT_AURA")
	this:RegisterEvent("PLAYER_DEAD")
	
--	print("Wintergrasper Advanced v2.00: LOADED")
end

function WG_OnEvent(event)
	if(event == "PLAYER_LOGIN")then
		if(GetWintergraspWaitTime() ~= nil)then
			WG_TimeGather()
		else
			if(IsInInstance() == nil)then
				WG_TimeBB = time()
			else
				WG_TimeBB = 0
			end
			WG_WindowToken:SetTexture("Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvP-FFA.tga")
		end
	end
	if(event=="CHAT_MSG_CHANNEL_NOTICE")then
		if(GetCurrentMapContinent() == 4)then
			if(UnitIsDeadOrGhost("player") ~= 1 and WG_MapName ~= nil)then
				WG_TimeGather()
			end
		end
	end
	if(event=="UNIT_AURA")then
		if(UnitBuff("player",WG_BUFFNAME) and GetCurrentMapContinent() == 4 and IsInInstance() == nil)then
			WG_TimeGather()
		end
	end
	if(event == "PLAYER_DEAD")then
		if(WG_MapName == "LakeWintergrasp" or 
		   WG_MapName == "AlteracValley" or
		   WG_MapName == "StrandoftheAncients" or
		   WG_MapName == "IsleofConquest" or
		   WG_MapName == "WarsongGulch" or
		   WG_MapName == "ArathiBasin" or
		   WG_MapName == "NetherstormArena" -- Eye of the Storm
		   )then
			RepopMe()
		end
--[[		if(GetRealmName() == "Destromath" and (WG_MapName == "AlteracValley" or
											   WG_MapName == "StrandoftheAncients" or 
											   WG_MapName == "WarsongGulch" or
											   WG_MapName == "ArathiBasin" or
											   WG_MapName == "IsleofConquest"
											   )
										   and UnitFactionGroup("player") == "Horde")then
			WG_SCTFRAME:AddMessage("Stop PvPing, idiot!", 1, 0, 0);
		end]]
	end
end

function WG_OnUpdate()
	WG_MapName = (select(1,GetMapInfo()))
	if(GetWintergraspWaitTime() ~= nil)then
		if(UnitInRaid("player") ~= nil)then
			if(GetWintergraspWaitTime() >= 7200)then
				WG_TimeGather()
			end
		end
		if(WG_TimeTillString == "|cffFFCC00"..WG_STARTED.."|r" and GetWintergraspWaitTime() < 8700)then
		--	print("2")
			if(WG_MapName == "LakeWintergrasp" and (UnitInRaid("player") or GetNumPartyMembers() > 0))then
				if(WG_Settings.AutoLeave == 1)then
					LeaveParty()
				else
					WG_RaidLeaveCheck()
				end
			end
			WG_TimeBB = GetWintergraspWaitTime()+time()
			WG_WindowToken:SetTexture("Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\QuestionMark.tga")
			factionicon='\124TInterface\\AddOns\\Wintergrasper_Advanced\\Icons\\QuestionMark.tga:32\124t '
		end
	end
	if(WG_TimeBB <= time())then
		if(IsInInstance() == nil)then
			WG_TimeTillString = "|cffFFCC00"..WG_STARTED.."|r"
		else
			WG_TimeTillString = "|cffFFCC00  N/A|r"
		end
	else
		WG_TimeTillString = WG_ConvertTime(math.abs(WG_TimeBB-time()))
	end
	if(WG_SoundPlayCheck ~= nil)then
		if(WG_SoundPlayCheck+3 < time())then
			WG_SoundPlayCheck = nil
		end
	end
--[[	if(WG_Settings.WGOWNERTIME ~= nil)then
		if(WG_Settings.WGOWNERTIME > WG_TimeBB+Time())then
			WG_Settings.WGOWNERTIME = nil
		end
	end]]
	WG_SCTCheck()
	WG_WindowMessage:SetText(WG_TimeTillString)
end

function WG_ConvertTime(value)
	local hours = floor(value / 3600)
	local minutes = value - (hours * 3600)
	minutescorrupt = floor(minutes / 60)
	if(minutescorrupt < 10)then minutesfixed = "0"..minutescorrupt..""
	else minutesfixed = minutescorrupt end
	local seconds = floor(value - ((hours * 3600) + (minutescorrupt * 60)))
	if(seconds < 10)then secondsfixed = "0"..seconds..""
	else secondsfixed = seconds end
	if (hours > 0) then
		return hours..":"..minutesfixed..":"..secondsfixed
	elseif (minutescorrupt > 0) then
		return "0:"..minutesfixed..":"..secondsfixed
	else
		return "0:00:"..secondsfixed
	end
end

function WG_SCTCheck()
	if(WG_TimeTillString == "0:15:00")then
		WG_SCTFRAME:AddMessage(factionicon..""..WG_ANNOUNCE1, 0.7, 0.7, 1);
		if(WG_SoundPlayCheck == nil)then
			PlaySoundFile("Sound\\Spells\\Blade_of_Azzinoth_Impact.wav")
			WG_SoundPlayCheck = time()
		end
	elseif(WG_TimeTillString == "0:05:00")then
		WG_SCTFRAME:AddMessage(factionicon..""..WG_ANNOUNCE2, 0.7, 0.7, 1);
		if(WG_SoundPlayCheck == nil)then
			PlaySoundFile("Sound\\Spells\\Blade_of_Azzinoth_Impact.wav")
			WG_SoundPlayCheck = time()
		end
	elseif(WG_TimeTillString == "0:00:01")then
		WG_SCTFRAME:AddMessage(factionicon..""..WG_ANNOUNCE3, 0.7, 0.7, 1);
		WG_WindowToken:SetTexture("Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvP-FFA.tga")
		if(WG_SoundPlayCheck == nil)then
			PlaySoundFile("Sound\\Spells\\Blade_of_Azzinoth_Impact.wav")
			WG_SoundPlayCheck = time()
		end
	end
end

function WG_TimeGather()
	if(GetCurrentMapContinent() == 4)then
		if(UnitBuff("player",WG_BUFFNAME))then
			if(UnitFactionGroup("player") == "Horde")then
				WG_WindowToken:SetTexture("Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPHorde.blp")
				factionicon='\124TInterface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPHorde.blp:32\124t '
			else
				WG_WindowToken:SetTexture("Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPAlliance.blp")
				factionicon='\124TInterface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPAlliance.blp:32\124t '
			end
		else
			if(UnitFactionGroup("player") == "Horde")then
				WG_WindowToken:SetTexture("Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPAlliance.blp")
				factionicon='\124TInterface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPAlliance.blp:32\124t '
			else
				WG_WindowToken:SetTexture("Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPHorde.blp")
				factionicon='\124TInterface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPHorde.blp:32\124t '
			end
		end
	else
		WG_WindowToken:SetTexture("Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\QuestionMark.tga")
		factionicon='\124TInterface\\AddOns\\Wintergrasper_Advanced\\Icons\\QuestionMark.tga:32\124t '
	end
	if(GetWintergraspWaitTime() ~= nil)then
		WG_TimeBB = GetWintergraspWaitTime()+time()
		--WG_Settings.TimeSaved = WG_TimeBB
	end
end

function MountInWG()
	if(GetWintergraspWaitTime()==nil and WG_MapName=="LakeWintergrasp")then
		return true
	else
		return false
	end
end

function WG_RaidLeaveCheck()
	local frame = CreateFrame("Frame", nil, UIParent)
		frame:SetFrameStrata("DIALOG")
		frame:SetWidth(250)
		frame:SetHeight(90)
		frame:SetPoint("CENTER", 0, 200)
		frame:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 32, edgeSize = 32,
		insets = {left = 8, right = 8, top = 8, bottom = 8},
	})
	local fontstring = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		fontstring:SetWidth(410)
		fontstring:SetHeight(0)
		fontstring:SetPoint("TOP", 0, -16)
		fontstring:SetText(WG_RAID_MSG)
	local button = CreateFrame("Button", nil, frame)
		button:SetHeight(25)
		button:SetWidth(85)
		button:SetPoint("CENTER", 50, -8)
		button:SetNormalFontObject("GameFontNormal")
		button:SetHighlightFontObject("GameFontHighlight")
		button:SetNormalTexture(button:CreateTexture(nil, nil, "UIPanelButtonUpTexture"))
		button:SetPushedTexture(button:CreateTexture(nil, nil, "UIPanelButtonDownTexture"))
		button:SetHighlightTexture(button:CreateTexture(nil, nil, "UIPanelButtonHighlightTexture"))
		button:SetText(WG_NO)
		button:SetScript("OnClick", function(self)
		frame:Hide()
	end)
	local button = CreateFrame("Button", nil, frame)
		button:SetHeight(25)
		button:SetWidth(85)
		button:SetPoint("CENTER", -50, -8)
		button:SetNormalFontObject("GameFontNormal")
		button:SetHighlightFontObject("GameFontHighlight")
		button:SetNormalTexture(button:CreateTexture(nil, nil, "UIPanelButtonUpTexture"))
		button:SetPushedTexture(button:CreateTexture(nil, nil, "UIPanelButtonDownTexture"))
		button:SetHighlightTexture(button:CreateTexture(nil, nil, "UIPanelButtonHighlightTexture"))
		button:SetText(WG_YES)
		button:SetScript("OnClick", function(self)
		frame:Hide()
		LeaveParty()
	end)
end